SystemOrganization addCategory: #'Cache-Analysis'!

TestCase subclass: #RunTimeCacheVarAnalysisTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!RunTimeCacheVarAnalysisTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 12:36'!
testOneCase

	|rtAnalysis|

	rtAnalysis := RunTimeCacheVarAnalysis new.
	(rtAnalysis runCase: (GLMPresentation -> #cachedDisplayedValue)) inspect.! !

TestCase subclass: #VariableReferenceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!VariableReferenceTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:13'!
setUp

	
	! !

!VariableReferenceTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 16:20'!
tearDown
	
	DummyClass recompile. "just in case"
	DummyClass class recompile. "just in case"
	DummyClass initialize.! !

!VariableReferenceTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:33'!
testInstanceSideIV

	| aSecondInstance reference dummyClassInstance |
	reference := VariableReference new on: DummyClass forVarNamed:  'instVar'; varTrace: true. 
	self assert: reference varInClass = DummyClass.
	self assert: reference traceType = InstSideVarTrace.
	self assert: reference varName = 'instVar'.
	self assert: reference varSites size = 4.
	reference install.
	dummyClassInstance := DummyClass new.
	self assert: reference ownerObjectToVarValueDict keys first = dummyClassInstance.
	self assert: (reference ownerObjectToVarValueDict at: dummyClassInstance) class = OrderedCollection.
	dummyClassInstance add: 5. 
	self assert: (reference ownerObjectToVarValueDict at: dummyClassInstance) first = 5.
	dummyClassInstance remove: 5.
	self assert: (reference ownerObjectToVarValueDict at: dummyClassInstance) isEmpty.
	dummyClassInstance add: 6.
	self assert: (reference ownerObjectToVarValueDict at: dummyClassInstance) first = 6.
	self assert: dummyClassInstance instVar __isAVariableReferenceProxy. 
	aSecondInstance := DummyClass new.
	self assert: (aSecondInstance instVar __isAVariableReferenceProxy) = true. "instrument multiple objects"
	aSecondInstance add: 42; add: 666; remove: 42.
	self assert: (reference ownerObjectToVarValueDict keys) size = 2. 
	self assert: (reference ownerObjectToVarValueDict at: aSecondInstance) first = 666.
	reference uninstall.
	self assert: dummyClassInstance instVar size = 1.
	self assert: dummyClassInstance instVar first = 6.
	reference varTrace inspect.
	"Transcript open. 
	reference __varTrace print."! !

!VariableReferenceTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 17:03'!
testSharedVar

	| aSecondInstance reference dummyClassInstance |
	reference := VariableReference new on: DummyClass forVarNamed:  'sharedVar'; varTrace: true. 
	self assert: reference varInClass = DummyClass.
	self assert: reference traceType = SharedVarTrace.
	self assert: reference varName = 'sharedVar'. 
	self assert: reference varSites size = 8. "lazy inits and also on the class side"
	reference install.
	dummyClassInstance := DummyClass new.
	self assert: reference ownerObjectToVarValueDict keys first = dummyClassInstance.
	self assert: (reference ownerObjectToVarValueDict at: dummyClassInstance) class = OrderedCollection.
	dummyClassInstance add: 5. 
	self assert: (reference ownerObjectToVarValueDict at: dummyClassInstance) first = 5.
	dummyClassInstance remove: 5.
	self assert: (reference ownerObjectToVarValueDict at: dummyClassInstance) isEmpty.
	dummyClassInstance add: 6.
	self assert: (reference ownerObjectToVarValueDict at: dummyClassInstance) first = 6.
	self assert: dummyClassInstance sharedVar __isAVariableReferenceProxy. 
	aSecondInstance := DummyClass new.
	self assert: (aSecondInstance sharedVar __isAVariableReferenceProxy) = true. "instrument multiple objects"
	(aSecondInstance class) add: 42; add: 666; remove: 42. "the same but from the class side"
	self assert: (reference ownerObjectToVarValueDict keys) size = 2. 
	self assert: (reference ownerObjectToVarValueDict at: aSecondInstance) first = 666.
	reference uninstall.
	self assert: dummyClassInstance sharedVar size = 1.
	self assert: dummyClassInstance sharedVar first = 6.
	reference varTrace inspect.
	"Transcript open. 
	reference __varTrace print."! !

Object subclass: #DummyClass
	instanceVariableNames: 'instVar'
	classVariableNames: 'sharedVar'
	poolDictionaries: ''
	category: 'Cache-Analysis'!

DummyClass class
	instanceVariableNames: 'classIV'!

DummyClass class
	instanceVariableNames: 'classIV'!

!DummyClass class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:11'!
add: anItem

	classIV add: anItem.
	sharedVar add: anItem.! !

!DummyClass class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:10'!
classIV

	^ classIV! !

!DummyClass class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:11'!
initialize

	classIV := OrderedCollection new.
	sharedVar := OrderedCollection new.! !

DummyClass initialize!

!DummyClass class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:12'!
remove: anItem

	classIV remove: anItem.
	sharedVar remove: anItem.! !

!DummyClass class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 17:01'!
sharedVar

	^ sharedVar := OrderedCollection new ! !

!DummyClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:36'!
add: anItem

	instVar add: anItem.
	sharedVar add: anItem.! !

!DummyClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 17:01'!
initialize

	instVar := OrderedCollection new.
	sharedVar := OrderedCollection new. ! !

!DummyClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:08'!
instVar

	^ instVar! !

!DummyClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 15:35'!
remove: anItem

	instVar remove: anItem.
	sharedVar remove: anItem.! !

!DummyClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 17:01'!
sharedVar

	^ sharedVar! !

Object subclass: #NaiveCacheDetector
	instanceVariableNames: ''
	classVariableNames: 'methodToCacheAssocList'
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 19:54'!
LRUCacheUsers
	"(self new LRUCacheUsers collect: [:method | method methodClass -> method selector]) printString"
	^ ((LRUCache allCallsOnIn: SystemNavigation new ) collect: [:method | method methodClass -> method selector]) remove: (NaiveCacheDetector->#LRUCacheUsers); asSet ! !

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 19:54'!
TTLCacheUsers
	"(self new TTLCacheUsers collect: [:method | method methodClass -> method selector]) printString"
	^ ((TTLCache allCallsOnIn: SystemNavigation new ) collect: [:method | method methodClass -> method selector]) remove: (NaiveCacheDetector->#TTLCacheUsers); asSet ! !

!NaiveCacheDetector methodsFor: 'automatic' stamp: 'NickPapoulias 9/8/2015 21:50'!
allAutomaticallyDetectedCaches

	^ ((self cacheNamedIVs union: self cacheNamedClassVars)
		union: (self LRUCacheUsers union: self TTLCacheUsers))
		union: (self cacheNamedTemporaries union: self autoDetectedBaseClassSingletonVars).! !

!NaiveCacheDetector methodsFor: 'full - union - intersection' stamp: 'NickPapoulias 9/8/2015 18:06'!
allCachesInTheSystem

	^ self allAutomaticallyDetectedCaches union: self allManuallyDetectedCaches.
		! !

!NaiveCacheDetector methodsFor: 'manual' stamp: 'NickPapoulias 9/9/2015 10:29'!
allManuallyDetectedCaches

	^ (self manualGeneralCaches union: self manualSessionCaches) union: self manualSingletonCaches! !

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 21:41'!
autoDetectedBaseClassSingletonVars

	|classToCacheAssocList ivName |
	classToCacheAssocList := OrderedCollection new.
	ProtoObject allSubclasses do: [ :class | 
		class isMeta
			ifFalse: [ 
				|selector|
				(class class methodDict keys includes: #uniqueInstance) 
					ifTrue: [selector := #uniqueInstance ] 
					ifFalse: [ (class class methodDict keys includes: #default) ifTrue: [ selector := #default ] ].
				selector ifNotNil:[
					[ivName := self cacheForClass: class withValue: (class perform: selector).
					classToCacheAssocList add: class -> ivName asSymbol] on: Exception do: ["some uniqueInstance calls misbehave"].
				]
			].
	].
	^ classToCacheAssocList asSet! !

!NaiveCacheDetector methodsFor: 'helpers' stamp: 'NickPapoulias 9/8/2015 21:32'!
cacheForClass: aClass withValue: aValue

	aClass class instanceVariables ifNotNilDo: [ :ivs | ivs do: [ :iv | 
		(aClass instVarNamed: iv) == aValue ifTrue: [ ^ iv ]	
	]].
	aClass class classVarNames ifNotNilDo: [ :vars | vars do: [ :iv | 
		(aClass classVarNamed: iv) == aValue ifTrue: [ ^ iv ]	
	]].
	^ nil! !

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 20:36'!
cacheNamedClassVars

	| classToCacheAssocList |
	classToCacheAssocList := OrderedCollection new.
	ProtoObject allSubclasses do: [ :class | 
		class ~= NaiveCacheDetector ifTrue: [  
			(self cachesForClassInClassVars: class)
				ifNotEmptyDo: [:caches | 
						caches do: [ :cache | classToCacheAssocList add: class -> cache asSymbol ]]
		]
	].
	^ classToCacheAssocList asSet! !

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 20:40'!
cacheNamedIVs

	| classToCacheAssocList |
	classToCacheAssocList := OrderedCollection new.
	ProtoObject allSubclasses do: [ :class |
		class ~= NaiveCacheDetector ifTrue: [   
			(self cachesForClass: class) 
				ifNotEmptyDo: [:caches | 
					caches do: [ :cache | classToCacheAssocList add: class -> cache asSymbol ]].
		]
	].
	^ classToCacheAssocList asSet! !

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 20:41'!
cacheNamedTemporaries

	methodToCacheAssocList ifNotNil: [ ^ methodToCacheAssocList ]. "takes time to compute cache it ;) -- is not counted for detection"
	methodToCacheAssocList := OrderedCollection new.
	CompiledMethod allInstances do: [ :method | 
		method methodClass ~= NaiveCacheDetector ifTrue: [  
			(self cachesForMethod: method) 
				ifNotEmptyDo: [:caches | 
						caches do: [ :cache | methodToCacheAssocList add: method -> cache asSymbol ]].
		].
	].
	^ methodToCacheAssocList := methodToCacheAssocList asSet! !

!NaiveCacheDetector methodsFor: 'helpers' stamp: 'NickPapoulias 9/2/2015 17:43'!
cachesForClass: aClass

	^ aClass instanceVariables ifNil: [ {  } ] ifNotNilDo: 
		[:ivs | (ivs select: [ :iv | iv includesSubstring: 'cache' caseSensitive: false ]) asOrderedCollection ]! !

!NaiveCacheDetector methodsFor: 'helpers' stamp: 'NickPapoulias 9/2/2015 17:43'!
cachesForClassInClassVars: aClass

	^ aClass classVarNames ifNil: [ {  } ] ifNotNilDo: 
		[:ivs | (ivs select: [ :iv | iv includesSubstring: 'cache' caseSensitive: false ]) asOrderedCollection ]! !

!NaiveCacheDetector methodsFor: 'helpers' stamp: 'NickPapoulias 9/8/2015 20:26'!
cachesForMethod: aMethod

	^ aMethod tempNames ifNil: [ {  } ] ifNotNilDo: 
		[:temps | (temps select: [ :temp | temp includesSubstring: 'cache' caseSensitive: false ]) asOrderedCollection ]! !

!NaiveCacheDetector methodsFor: 'full - union - intersection' stamp: 'NickPapoulias 9/8/2015 18:11'!
intersectionOfAutoAndManualDetected

	^ self allAutomaticallyDetectedCaches intersection: self allManuallyDetectedCaches.
		! !

!NaiveCacheDetector methodsFor: 'manual' stamp: 'NickPapoulias 9/9/2015 10:23'!
manualGeneralCaches

	^ {ASTCache -> #default.
AbstractMethodWidget -> #MethodsIconsCache.
AbstractNautilusUI -> #ClasssesIconsCache.
AbstractNautilusUI -> #GroupsIconsCache.
AbstractNautilusUI -> #PackagesIconsCache.
BitBlt -> #CachedFontColorMaps.
BitBlt -> #ColorConvertingMaps.
CairoBackendCache -> #soleInstance.
Color -> #CachedColormaps.
Color -> #MaskingMap.
FreeTypeCache -> #current.
GLMUIThemeExtraIcons -> #icons.
GradientFillStyle -> #PixelRampCache.
HelpIcons -> #Icons.
KomitClass -> #classes.
KomitMethod -> #methods.
KomitPackage -> #packages.
KomitRemote -> #icon.
Komitter -> #lastMessage.
LoadingMorphState -> #image.
LogicalFont -> #all.
MCDefinition -> #Instances.
MCGitHubRepository -> #DownloadCache.
MCMethodDefinition -> #Definitions.
MCSaveVersionDialog -> #PreviousMessages.
NECSymbols -> #cachedSymbols.
RPackageSet -> #cachePackages.
ScrollBar -> #ArrowImagesCache.
ScrollBar -> #BoxesImagesCache.
SettingDeclaration -> #ValueListCache.
SingleCodeCriticResultList -> #icons.
SugsSuggestionFactory -> #collectorForAll.
SugsSuggestionFactory -> #collectorForAssignment.
SugsSuggestionFactory -> #collectorForClassVariable.
SugsSuggestionFactory -> #collectorForClass.
SugsSuggestionFactory -> #collectorForInstancesVariable.
SugsSuggestionFactory -> #collectorForLiteral.
SugsSuggestionFactory -> #collectorForMessage.
SugsSuggestionFactory -> #collectorForMethod.
SugsSuggestionFactory -> #collectorForSourceCode.
SugsSuggestionFactory -> #collectorForTemporaryVariable.
SugsSuggestionFactory -> #collectorForUndeclaredVariable.} asSet! !

!NaiveCacheDetector methodsFor: 'manual' stamp: 'NickPapoulias 9/9/2015 10:27'!
manualSessionCaches

	^ {MCGitHubRepository -> #DownloadCache.
MCCacheRepository -> #default.
DiskStore -> #CurrentFS.
NOCCompletionTable -> #table.
NOCCompletionTable -> #classTable.
Locale -> #Current.
Locale -> #CurrentPlatform.
DateAndTime -> #LocalTimeZone.
FT2Handle -> #Session.
FileLocator -> #Resolver.
FileStream -> #Stdin.
FileStream -> #Stdout.
FileStream -> #TheStdioHandles.
FileStream -> #StdioFiles.
FileStream -> #Stderr.
LanguageEnvironment -> #SystemConverter.
LanguageEnvironment -> #FileNameConverter.
UUIDGenerator -> #Default.
VirtualMachine -> #WordSize.
WeakFinalizationList -> #HasNewFinalization.
AthensCairoSurface -> #uniqueSession.
AthensCairoSurface -> #dispatch.
AthensCairoSurface -> #dispatchStruct.
CairoLibraryLoader -> #session .
CairoLibraryLoader -> #libHandle.
Session -> #current.
MultiByteFileStream -> #LineEndDefault} asSet! !

!NaiveCacheDetector methodsFor: 'manual' stamp: 'NickPapoulias 9/9/2015 10:25'!
manualSingletonCaches

	^ {ASTCache -> #default.
ActiveEvent -> #ActiveEvent.
ActiveHand -> #ActiveHand.
ActiveWorld -> #ActiveWorld.
Author -> #uniqueInstance.
BorderStyle -> #Default.
CPUWatcher -> #CurrentCPUWatcher.
CairoBackendCache -> #soleInstance.
ChangesLog -> #DefaultInstance.
Clipboard -> #Default.
CommandLineArguments -> #singleton.
CriticWorkingConfiguration -> #Current.
Display -> #Display.
EditorFindReplaceDialogWindow -> #Singleton.
EmptyLayout -> #instance.
FreeTypeCache -> #current.
FreeTypeSettings -> #current.
IdentityTransform -> #Default.
InputEventFetcher -> #Default.
KMBuffer -> #uniqueInstance.
KMPragmaKeymapBuilder -> #UniqueInstance.
KMRepository -> #Singleton.
KomitterManager -> #instance.
LayoutEmptyScope -> #instance.
LogicalFontManager -> #current.
MBConfigurationRoot -> #Current.
MCFileTreeFileUtils -> #Current.
MCRepositoryGroup -> #default.
MCServerRegistry -> #uniqueInstance.
MetacelloPlatform -> #Current.
NBExternalResourceManager -> #soleInstance.
NECController -> #uniqueInstance.
NNavNavigation -> #Instance.
NNavNavigation -> #Instance.
NativeBoost -> #Current.
NautilusMonticello -> #Default.
OSPlatform -> #Current.
PharoFilesOpener -> #Default.
ProcessSpecificVariable -> #soleInstance.
Processor -> #Processor.
RBRefactoringManager -> #Instance.
RBRefactoryChangeManager -> #Instance.
RPackageOrganizer -> #default.
RecentMessageList -> #UniqueInstance.
Sensor -> #Sensor.
Smalltalk -> #Smalltalk.
SoundTheme -> #Current.
SourceFiles -> #SourceFiles.
StartupPreferencesLoader -> #UniqueInstance.
SystemAnnouncer -> #announcer.
SystemOrganization -> #SystemOrganization.
SystemProgressMorph -> #UniqueInstance.
SystemVersion -> #Current.
Transcript -> #Transcript.
UUIDGenerator -> #Default.
Undeclared -> #Undeclared.
VTermOutputDriver -> #stderrTerminalInstance.
VTermOutputDriver -> #stdoutTerminalInstance.
World -> #World.
ZnNetworkingUtils -> #Default.} asSet! !

!NaiveCacheDetector methodsFor: 'full - union - intersection' stamp: 'NickPapoulias 9/9/2015 19:32'!
packageAnalysis

	"easy and nice to have, plus it will help with analysis of third-party projects"

	| packageToNumberOfCachesDict |
	packageToNumberOfCachesDict := Dictionary new.
	
	self allCachesInTheSystem do: [ :assoc | "temps or users are methods to varName" 
		|package|
		package := assoc key isClass | (assoc key class = CompiledMethod)  
			ifTrue: [ assoc key package ]  
			ifFalse: [ assoc key class package ]. "is an object -- investigate which detector did this"		
			(packageToNumberOfCachesDict keys includes: package)
				ifTrue: [ 
					packageToNumberOfCachesDict 
						at: package 
						put: (packageToNumberOfCachesDict at: package) + 1 ]
				ifFalse: [ packageToNumberOfCachesDict at: package put:  1 ]
	].

	^ packageToNumberOfCachesDict  
		
		! !

!Object methodsFor: '*Cache-Analysis' stamp: 'NickPapoulias 9/10/2015 10:03'!
__isAVariableReferenceProxy

	^ false! !

Object subclass: #PlaygroundAnalysisSetNick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/2/2015 12:34'!
browseAllAccessesTo: aVar from: aClass

	SystemNavigation default browseAllAccessesTo: aVar from: aClass! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/2/2015 12:43'!
browseAllAccessesToClassVar: aVar from: aClass

	SystemNavigation default browseAllReferencesTo:
		(aClass classPool associationAt: aVar)! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 17:01'!
infoOnClassSideIV: ivName inClass: aClass! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 17:04'!
infoOnClassVariable: cvarName inClass: aClass! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 17:01'!
infoOnInstanceSideIV: ivName inClass: aClass! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/8/2015 18:11'!
manualExample

	PlaygroundAnalysisSetNick new browseAllAccessesToClassVar: #DownloadCache from: MCGitHubRepository.  

	(MCGitHubRepository classPool at: #DownloadCache) class.
	(MCGitHubRepository classPool at: #DownloadCache) size.
	(MCGitHubRepository classPool at: #DownloadCache) anyOne class.! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/8/2015 18:11'!
manualExampleClassPool

	PlaygroundAnalysisSetNick new browseAllAccessesToClassVar: #DownloadCache from: MCGitHubRepository.  

	(MCGitHubRepository classPool at: #DownloadCache) class.
	(MCGitHubRepository classPool at: #DownloadCache) size.
	(MCGitHubRepository classPool at: #DownloadCache) anyOne class.! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/8/2015 18:11'!
manualExampleInstanceSide

	|instance|

	PlaygroundAnalysisSetNick new browseAllAccessesTo: #cachedPresentation from: GLMDynamicPresentation.  
	
	instance := GLMDynamicPresentation allInstances isEmpty
						ifTrue: [ GLMDynamicPresentation new ]
						ifFalse: [ GLMDynamicPresentation allInstances anyOne ].

	(instance instVarNamed: #cachedPresentation) class.
	(instance instVarNamed: #cachedPresentation) size.
	(instance instVarNamed: #cachedPresentation) anyOne class.! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:44'!
manuallyIDedIWSTpaperSession

	^  { FileStream -> #Stderr.
LanguageEnvironment -> #SystemConverter.
LanguageEnvironment -> #FileNameConverter.
UUIDGenerator -> #Default.
VirtualMachine -> #WordSize.
WeakFinalizationList -> #HasNewFinalization.
AthensCairoSurface -> #uniqueSession.
AthensCairoSurface -> #dispatch.
AthensCairoSurface -> #dispatchStruct.
CairoLibraryLoader -> #session.
CairoLibraryLoader -> #libHandle.
Session -> #current.
MultiByteFileStream -> #LineEndDefault. }! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/2/2015 20:10'!
manuallyIDedIWSTpaperSingletons

	^ {NNavNavigation -> #Instance.
NativeBoost -> #Current.
NautilusMonticello -> #Default.
OSPlatform -> #Current.
"PackageOrganizer -> #default."
PharoFilesOpener -> #Default.
"PharoTutorial -> #Instance."
ProcessSpecificVariable -> #soleInstance.
Processor -> #Processor.
RBRefactoringManager -> #Instance.
RBRefactoryChangeManager -> #Instance.
RPackageOrganizer -> #default.
RecentMessageList -> #UniqueInstance.
Sensor -> #Sensor.
"SharedValueHolder -> #instance"
Smalltalk -> #Smalltalk.
SoundTheme -> #Current.
SourceFiles -> #SourceFiles.
"Spotlight -> #Current"
StartupPreferencesLoader -> #UniqueInstance.
SystemAnnouncer -> #announcer.
SystemOrganization -> #SystemOrganization.
SystemProgressMorph -> #UniqueInstance.
SystemVersion -> #Current.
Transcript -> #Transcript.
UUIDGenerator -> #Default.
Undeclared -> #Undeclared.
"UserManager -> #default"
VTermOutputDriver -> #stderrTerminalInstance.
VTermOutputDriver -> #stdoutTerminalInstance.
World -> #World.
ZnNetworkingUtils -> #Default}! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:42'!
manuallyIDedIWSTpaperVarious

	^ { MCDefinition -> #Instances.
MCGitHubRepository -> #DownloadCache.
MCMethodDefinition -> #Definitions.
MCSaveVersionDialog -> #PreviousMessages.
NECSymbols -> #cachedSymbols.
RPackageSet -> #cachePackages.
ScrollBar -> #ArrowImagesCache.
ScrollBar -> #BoxesImagesCache.
SettingDeclaration -> #ValueListCache.
SingleCodeCriticResultList -> #icons.
SugsSuggestionFactory -> #collectorForAll.
SugsSuggestionFactory -> #collectorForAssignment.
SugsSuggestionFactory -> #collectorForClassVariable.
SugsSuggestionFactory -> #collectorForClass.
SugsSuggestionFactory -> #collectorForInstancesVariable.
SugsSuggestionFactory -> #collectorForLiteral.
SugsSuggestionFactory -> #collectorForMessage.
SugsSuggestionFactory -> #collectorForMethod.
SugsSuggestionFactory -> #collectorForSourceCode.
SugsSuggestionFactory -> #collectorForTemporaryVariable.
SugsSuggestionFactory -> #collectorForUndeclaredVariable. }! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:31'!
naiveDetectorCacheIvs

	 ^ {GLMDynamicPresentation->#(#cachedPresentation). PNGReadWriter->#(#cachedDecoderMap). Color->#(#cachedDepth #cachedBitPattern). TextContainer->#(''rectangleCache''). MetacelloCommonMCSpecLoader->#(''disablePackageCache''). FreeTypeFont->#(''widthAndKernedWidthCache'' ''cachedHeight'' ''cachedAscent'' ''cachedDescent''). RBVariableEnvironment->#(''selectorCache''). ColorForm->#(''cachedDepth'' ''cachedColormap''). SystemDictionary->#(''cachedClassNames'' ''cachedNonClassNames''). SpecDebuggerStack->#(#actionsCache). NECSymbols class->#(''cachedSymbols''). EmbeddedFreeTypeFontInstaller->#(#embeddedFileInfoCache). StackLayout->#(''cachedMinExtent'' ''cachedMinExtents''). FreeTypeFontProvider->#(#fileInfoCache). MetacelloCachingGoferResolvedReference->#(''cachedVersion''). RowLayout->#(''cachedMinExtent'' ''cachedMinExtents''). MCHttpRepository->#(#readerCache). HandMorph->#(#cacheCanvas #cachedCanvasHasHoles). MessageBrowser->#(#cachedHierarchy). NewListModel->#(#listItemsCache). GTSpotterContext->#(#cache). RBNamespace->#(''implementorsCache'' ''sendersCache''). ListModel->#(#listItemsCache). RBSentNotImplementedRule->#(#implementorsCache). MetacelloLoaderPolicy->#(''cacheRepository'' ''cacheGofer''). VSCommitBrowser class->#(#commentCache). Termcap->#(''cache''). TableLayout->#(''minExtentCache''). SeamlessFastDNUProxy->#(#cachedClassProxy). PluggableListMorph->#(#hScrollRangeCache). FileDialogWindow->#(#entryCache #entryCacheDirectory). InteractiveResolver->#(''cache''). MailAddressTokenizer->#(#cachedToken). ClassWidget->#(#cachedHierarchy). GoferSynchronize->#(''cacheReferences''). GLMDynamicPresentation2->#(#cachedPresentation). ASTCacheResetTest->#(#cache). MCRepositoryGroup->#(''useCache''). CairoFontMetricsProvider->#(#cache). Gofer->#(''packageCacheRepository'' ''resolvedReferencesCache''). ProgressBarMorph->#(#cachedWidth). MethodFinder->#(#cachedClass #cachedArgNum #cachedSelectorLists). MCCacheRepository->#(#packageCaches #cacheEnabled). RPackageSet class->#(#cacheActive #cachePackages). MetacelloClearStackCacheNotification->#(''cacheNames''). HelpBrowser->#(#helpTopicCache). CharacterSetComplement->#(''byteArrayMapCache''). AlphaImageMorph->#(#cachedForm). CairoFreetypeFontRenderer->#(#cache). MCFileTreeWriter->#(#cachedPackageFileDirectoryEntries). GLMPresentation->#(#cachedDisplayedValue). GTPlayBook class->#(#cacheDirectory). MCFileBasedRepository->#(#cache #cacheFileNames). GLMPane->#(#cachedMatchingPresentations). NewList->#(#listCache #displayListCache #iconCache). CriticBrowser->#(#cache). SingleCodeCriticResultList->#(#cache). AbstractNautilusUI->#(#cachedHierarchy). FreeTypeCacheTest->#(''cache'' ''cache1K'' ''fullCache''). SmalllintManifestChecker->#(''manifestClassCache''). CairoBackendCache->#(''cache''). MCMczReader->#(''infoCache'')}! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/2/2015 14:03'!
naiveLRUUsers

	 ^ {BlockClosureTest->#testMemoizedLRUCache . GradientFillStyle class->#initPixelRampCache . LRUCacheTests->#newCache . ThemeIcons->#initializeIcons . UITheme->#createArrowImagesCache . UITheme->#createBoxImagesCache}
! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:39'!
naiveTTLUsers

	 ^ {TTLCacheTests->#newCache}! !

Object subclass: #RunTimeCacheVarAnalysis
	instanceVariableNames: 'caseToTraceDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!RunTimeCacheVarAnalysis methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 12:33'!
conformantSet

	^ (NaiveCacheDetector new allCachesInTheSystem select: [ :assoc | assoc key isBehavior ]) 
		select: [ :assoc | 
			(Smalltalk globals keys includes: (assoc key name asString , 'Test') asSymbol)
		]! !

!RunTimeCacheVarAnalysis methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 12:34'!
conformantSetWithGreenTests

	^ (NaiveCacheDetector new allCachesInTheSystem select: [ :assoc | assoc key isBehavior ]) 
		select: [ :assoc | 
			(Smalltalk globals keys includes: (assoc key name asString , 'Test') asSymbol) and: 
			[(Smalltalk globals at: (assoc key name asString , 'Test') asSymbol) buildSuiteFromAllSelectors run hasPassed]
		] ! !

!RunTimeCacheVarAnalysis methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 12:00'!
intialize

	super initialize.
	caseToTraceDict := Dictionary new.! !

!RunTimeCacheVarAnalysis methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 11:57'!
runAll

	"one step at a time -- run an example first in the test"! !

!RunTimeCacheVarAnalysis methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 12:20'!
runCase: aClassToVarAssoc

	|reference|

	reference := VariableReference new on: aClassToVarAssoc key forVarNamed: aClassToVarAssoc value; varTrace: true.
	reference install.
	(Smalltalk globals at: (aClassToVarAssoc key theNonMetaClass name , 'Test') asSymbol) buildSuiteFromAllSelectors run.
	reference uninstall.
	^ reference varTrace.! !

Object subclass: #VarEvent
	instanceVariableNames: 'ownerHash fromMethod fromReceiverClass currentValueClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarEvent subclass: #MsgSendEvent
	instanceVariableNames: 'selector argClasses returnValueClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!MsgSendEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:41'!
argClasses
	^ argClasses! !

!MsgSendEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:41'!
argClasses: anObject
	argClasses := anObject! !

!MsgSendEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:41'!
returnValueClass
	^ returnValueClass! !

!MsgSendEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:41'!
returnValueClass: anObject
	returnValueClass := anObject! !

!MsgSendEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:41'!
selector
	^ selector! !

!MsgSendEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:41'!
selector: anObject
	selector := anObject! !

VarEvent subclass: #ReadEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!VarEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:37'!
currentValueClass
	^ currentValueClass! !

!VarEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:37'!
currentValueClass: anObject
	currentValueClass := anObject! !

!VarEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 23:52'!
fromContext: aContext
	fromMethod := aContext method.
	fromReceiverClass := aContext receiver class.! !

!VarEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:38'!
fromMethod
	^ fromMethod! !

!VarEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 00:02'!
fromReceiverClass
	^ fromReceiverClass ! !

!VarEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:58'!
ownerHash
	^ ownerHash! !

!VarEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:58'!
ownerHash: anObject
	ownerHash := anObject! !

VarEvent subclass: #WriteEvent
	instanceVariableNames: 'newValueClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!WriteEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:42'!
newValueClass
	^ newValueClass! !

!WriteEvent methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 22:42'!
newValueClass: anObject
	newValueClass := anObject! !

Object subclass: #VarSite
	instanceVariableNames: 'method node link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarSite subclass: #ReadVarSite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!ReadVarSite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 16:52'!
linkFor: aMetaObject

	^ link ifNil: [link := MetaLink new 
		metaObject: aMetaObject; 
		selector: #readForOwner:;
		control: #instead;
		options: #(+ optionCompileOnLinkInstallation);
		arguments: #(object)]! !

!VarSite class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/9/2015 18:32'!
readSitesOf: aVarName in: aMethod

	^ (aMethod variableReadNodes select: [ :node | node name = aVarName ]) collect: [ :node | ReadVarSite new on: node inside: aMethod ].! !

!VarSite class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/9/2015 18:32'!
writeSitesOf: aVarName in: aMethod

	^ (aMethod variableWriteNodes select: [ :node | node name = aVarName ]) collect: [ :node | WriteVarSite new on: node inside: aMethod ]! !

!VarSite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/9/2015 20:30'!
instrumentFor: aMetaObject

	node link: (self linkFor: aMetaObject).! !

!VarSite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/9/2015 18:28'!
linkFor: aMetaObject

	self subclassResponsibility ! !

!VarSite methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 18:51'!
method
	^ method! !

!VarSite methodsFor: 'accessing' stamp: 'NickPapoulias 9/9/2015 18:51'!
node
	^ node! !

!VarSite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/9/2015 18:11'!
on: aNode inside: aMethod 

	node := aNode.
	method := aMethod.! !

!VarSite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/9/2015 18:51'!
uninstallInstrumentation

	link uninstall! !

VarSite subclass: #WriteVarSite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!WriteVarSite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 16:52'!
linkFor: aMetaObject

	^ link ifNil: [link := MetaLink new 
		metaObject: aMetaObject; 
		selector: #write:forOwner:;
		control: #instead;
		options: #(+ optionCompileOnLinkInstallation);
		arguments: #(newValue object)]! !

Object subclass: #VarTrace
	instanceVariableNames: 'reference events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarTrace subclass: #ClassSideVarTrace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarTrace subclass: #InstSideVarTrace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarTrace subclass: #SharedVarTrace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarTrace subclass: #TempVarTrace
	instanceVariableNames: 'methodOfVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!VarTrace methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/9/2015 22:21'!
add: aVarEvent

	events addLast: aVarEvent.
	! !

!VarTrace methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 10:55'!
addExecuteFrom: aContext withCurrentValueClass: aValueClass withSelector: aSelector argumentClasses: argumentClasses andReturnValueClass: returnValueClass forOwner: anObject

	(self instrumentationReceiverClasses includes: aContext receiver class) ifTrue: [ ^ self ]. "dont' trace events from within instrumentation" 

	self add: (MsgSendEvent new 
					fromContext: aContext;
					currentValueClass: aValueClass;
					selector: aSelector;
					argClasses: argumentClasses;
					returnValueClass: returnValueClass;
					ownerHash: anObject hash)! !

!VarTrace methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 10:56'!
addReadFrom: aContext withCurrentValueClass: aValueClass forOwner: anObject

	self add: (ReadEvent new 
					fromContext: aContext;
					currentValueClass: aValueClass;
					ownerHash: anObject hash)

	! !

!VarTrace methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 10:56'!
addWriteFrom: aContext withCurrentValueClass: aValueClass andNewValueClass: aNewValueClass forOwner: anObject

	self add: (WriteEvent new 
					fromContext: aContext;
					currentValueClass: aValueClass;
					newValueClass: aNewValueClass;
					ownerHash: anObject hash )

	! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 00:11'!
allExecuteArgClasses

	^ ((events select: [ :event | event class = MsgSendEvent ]) 
			flatCollect: [ :event | event argClasses ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:56'!
allExecuteFromMethodClasses

	^ ((events select: [ :event | event class = MsgSendEvent ]) 
			collect: [ :event | event fromMethod methodClass ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:29'!
allExecuteFromMethods

	^ ((events select: [ :event | event class = MsgSendEvent ]) 
			collect: [ :event | event fromMethod ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:29'!
allExecuteFromPackages

	^ ((events select: [ :event | event class = MsgSendEvent ]) 
			collect: [ :event | event fromMethod methodClass package ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:55'!
allExecuteFromReceiverClasses

	^ ((events select: [ :event | event class = MsgSendEvent ]) 
			collect: [ :event | event fromReceiverClass ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 00:11'!
allExecuteReturnClasses

	^ ((events select: [ :event | event class = MsgSendEvent ]) 
			collect: [ :event | event returnValueClass ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:58'!
allFromMethodClasses

	^ (events collect: [ :event | event fromMethod methodClass ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:25'!
allFromMethods

	^ (events collect: [ :event | event fromMethod ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:25'!
allFromPackages

	^ (events collect: [ :event | event fromMethod methodClass package ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:59'!
allFromReceiverClasses

	^ (events collect: [ :event | event fromReceiverClass ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 11:01'!
allOwnersHash

	^ (events  
		collect: [ :event | event ownerHash ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:30'!
allReadFromMethods

	^ ((events select: [ :event | event class = ReadEvent ]) 
			collect: [ :event | event fromMethod methodClass ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:33'!
allSelectors

	^ ((events select: [ :event | event class = MsgSendEvent ]) 
			collect: [ :event | event selector ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 11:34'!
allSelectorsFromOutsideOwnersClass

	^ ((events select: [ :event | (event class = MsgSendEvent) & (event fromMethod methodClass = reference varInClass) not ]) 
			collect: [ :event | event selector ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 11:34'!
allSelectorsFromWithinOwnersClass

	^ ((events select: [ :event | (event class = MsgSendEvent) & (event fromMethod methodClass = reference varInClass) ]) 
			collect: [ :event | event selector ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:24'!
allValueClasses

	^ (events collect: [ :event | event currentValueClass ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:31'!
allWriteFromMethods

	^ ((events select: [ :event | event class = WriteEvent ]) 
			collect: [ :event | event fromMethod methodClass ]) asSet! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/9/2015 23:21'!
events

	^ events! !

!VarTrace methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/9/2015 22:20'!
for: aReference

	reference := aReference. 
	events := OrderedCollection new.! !

!VarTrace methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 00:04'!
instrumentationReceiverClasses

	^ { RBLiteralNode class . IRBytecodeGenerator . HookGenerator . OCLiteralList . OCLiteralSet . MetaLink }! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 12:43'!
traceType

	^ self class! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 10:14'!
tracingClass
	
	^ reference varInClass! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 10:34'!
varName
	
	^ reference varName! !

!VarTrace methodsFor: 'accessors-and-stats' stamp: 'NickPapoulias 9/10/2015 10:34'!
varSites
	
	^ reference varSites! !

Object subclass: #VariableReference
	instanceVariableNames: 'class varName varSites varTrace varTraceFlag ownerObjectToVarValueDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!VariableReference methodsFor: 'helpers' stamp: 'NickPapoulias 9/10/2015 17:12'!
checkPreExistingValueForOwner: anInstrumentedObject

	((self ownersStoredValue: anInstrumentedObject) __isAVariableReferenceProxy) 
		ifFalse: [ 
			ownerObjectToVarValueDict at: (self properSideOf: anInstrumentedObject) put: (self ownersStoredValue: anInstrumentedObject).
			self owner: anInstrumentedObject storeValueInVar: (VariableReferenceProxy new 
																			__instrumentedObject: anInstrumentedObject;  
																			__variableReference: self).  ].
		! !

!VariableReference methodsFor: 'helpers' stamp: 'NickPapoulias 9/10/2015 17:12'!
currentValueForOwner: anObject

	^ ownerObjectToVarValueDict at: (self properSideOf: anObject) ! !

!VariableReference methodsFor: 'rwx' stamp: 'NickPapoulias 9/10/2015 10:52'!
execute: aSelector withArgs: arguments forOwner: anObject from: aProxy

	"we end-up here (receiving a message) from a reference inside/propagated from myInstrumentedObject read/writes"

	| returnValue |
	returnValue := [(self currentValueForOwner: anObject) perform: aSelector withArguments: arguments] on: Exception do: [:ex | self uninstall. ex signal].
	self traceExecuteWithSelector: aSelector arguments: arguments andReturnValue: returnValue forOwner: anObject.
	^ returnValue == (self currentValueForOwner: anObject) "this cascading effect is debatable how usefull will be"
		ifTrue: [ aProxy ]
		ifFalse: [ returnValue ] ! !

!VariableReference methodsFor: 'install-uninstall' stamp: 'NickPapoulias 9/10/2015 10:25'!
install

	varSites do: [ :varSite | varSite instrumentFor: self ].! !

!VariableReference methodsFor: 'install-uninstall' stamp: 'NickPapoulias 9/10/2015 15:29'!
on: aClass forClassSideVarNamed: aVarName

	"the same but for the metaclass dict"
	
	self on: aClass class forInstanceSideVarNamed: aVarName! !

!VariableReference methodsFor: 'install-uninstall' stamp: 'NickPapoulias 9/10/2015 15:29'!
on: aClass forInstanceSideVarNamed: aVarName

	varSites "now this can be done for the subclasses as well -- but this is good enough for now"
		addAll: (aClass methodDict values flatCollect: [ :method | VarSite readSitesOf: aVarName in: method  ]);
		addAll: (aClass methodDict values flatCollect: [ :method | VarSite writeSitesOf: aVarName in: method  ]).! !

!VariableReference methodsFor: 'install-uninstall' stamp: 'NickPapoulias 9/10/2015 15:30'!
on: aClass forSharedVarNamed: aVarName

	"can be accessed by both instance side and class side"

	self on: aClass forInstanceSideVarNamed: aVarName.
	self on: aClass forClassSideVarNamed: aVarName.! !

!VariableReference methodsFor: 'install-uninstall' stamp: 'NickPapoulias 9/10/2015 15:41'!
on: aClass forVarNamed: aVarName

	"determine where the var belongs and call the right on:for: method"
	
	varTraceFlag := false.
	varName := aVarName.
	class := aClass.
	ownerObjectToVarValueDict := Dictionary new.
	varSites := OrderedCollection new.
	
	(aClass instanceVariables includes: aVarName)
		ifTrue: [ varTrace := InstSideVarTrace new for: self . ^ self on: aClass forInstanceSideVarNamed: aVarName ].
	aClass class instanceVariables ifNotNilDo: [ :mClassIvs | 
		(mClassIvs includes: aVarName)
			ifTrue: [ class := aClass class. varTrace := ClassSideVarTrace new for: self . ^ self on: aClass forClassSideVarNamed: aVarName ]].
	(aClass classVarNames includes: aVarName)
		ifTrue: [ varTrace := SharedVarTrace new for: self . ^ self on: aClass forSharedVarNamed: aVarName ].
	self error: 'No such varName in instance, class or shared'
	
	! !

!VariableReference methodsFor: 'helpers' stamp: 'NickPapoulias 9/10/2015 17:15'!
owner: anOwner storeValueInVar: aValue

	^ self traceType = SharedVarTrace 
		ifTrue: [ (self properSideOf: anOwner) classVarNamed: varName put: aValue ]
		ifFalse: [ anOwner instVarNamed: varName put: aValue ]! !

!VariableReference methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:59'!
ownerObjectToVarValueDict
	^ ownerObjectToVarValueDict! !

!VariableReference methodsFor: 'helpers' stamp: 'NickPapoulias 9/10/2015 17:15'!
ownersStoredValue: anOwner

	^ self traceType = SharedVarTrace 
		ifTrue: [ (self properSideOf: anOwner) classVarNamed: varName ]
		ifFalse: [ anOwner instVarNamed: varName ] ! !

!VariableReference methodsFor: 'helpers' stamp: 'NickPapoulias 9/10/2015 17:11'!
properSideOf: anOwner

	^ self traceType = SharedVarTrace 
				ifTrue: [ anOwner isBehavior ifTrue: [ anOwner ] ifFalse: [ anOwner class ] ]
				ifFalse: [ anOwner ]. 
	! !

!VariableReference methodsFor: 'rwx' stamp: 'NickPapoulias 9/10/2015 12:56'!
readForOwner: anObject

	self checkPreExistingValueForOwner: anObject; traceReadForOwner: anObject. 
	^ self ownersStoredValue: anObject. "this will return the proxy which will be already installed"! !

!VariableReference methodsFor: 'helpers' stamp: 'NickPapoulias 9/10/2015 17:14'!
restoreAllValues

	ownerObjectToVarValueDict ifNotNilDo: [ :dict | dict keysAndValuesDo: [ :insObj :value |  self owner: insObj storeValueInVar: value.  ]]! !

!VariableReference methodsFor: 'tracing' stamp: 'NickPapoulias 9/10/2015 10:53'!
traceExecuteWithSelector: aSelector arguments: arguments andReturnValue: returnValue forOwner: anObject

	"we end-up here (receiving a message) from a reference inside/propagated from myInstrumentedObject read/writes"

	varTraceFlag ifTrue: [ varTrace addExecuteFrom: thisContext sender sender sender 
											withCurrentValueClass: ownerObjectToVarValueDict class  
											withSelector: aSelector 
											argumentClasses: (arguments collect: [:arg | arg class])  
											andReturnValueClass: returnValue class
											forOwner: anObject. ]! !

!VariableReference methodsFor: 'tracing' stamp: 'NickPapoulias 9/10/2015 10:53'!
traceReadForOwner: anObject

	varTraceFlag ifTrue: [ varTrace addReadFrom: thisContext sender sender withCurrentValueClass: ownerObjectToVarValueDict class forOwner: anObject  ]! !

!VariableReference methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 12:42'!
traceType

	^ varTrace class! !

!VariableReference methodsFor: 'tracing' stamp: 'NickPapoulias 9/10/2015 10:53'!
traceWriteWithNewValue: aValue forOwner: anObject

	varTraceFlag ifTrue: [ varTrace addWriteFrom: thisContext sender sender withCurrentValueClass: ownerObjectToVarValueDict class  andNewValueClass: aValue class forOwner: anObject ]
! !

!VariableReference methodsFor: 'install-uninstall' stamp: 'NickPapoulias 9/10/2015 11:11'!
uninstall

	self varTrace: false. "you don't want"
	self restoreAllValues.
	varSites do: [ :varSite |  varSite uninstallInstrumentation ].
	ownerObjectToVarValueDict := nil. "free references"! !

!VariableReference methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:14'!
varInClass

	^ class! !

!VariableReference methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:34'!
varName

	^ varName! !

!VariableReference methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:34'!
varSites

	^ varSites ! !

!VariableReference methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:35'!
varTrace

	^ varTrace! !

!VariableReference methodsFor: 'tracing' stamp: 'NickPapoulias 9/10/2015 10:35'!
varTrace: aBoolean

	varTraceFlag := aBoolean! !

!VariableReference methodsFor: 'rwx' stamp: 'NickPapoulias 9/10/2015 12:56'!
write: aValue forOwner: anObject

	self checkPreExistingValueForOwner: anObject; traceWriteWithNewValue: aValue forOwner: anObject.
	ownerObjectToVarValueDict at: anObject put: aValue. 
	^ self ownersStoredValue: anObject. "this will return the proxy which will be already installed"! !

Object subclass: #VariableReferenceProxy
	instanceVariableNames: 'instrumentedObject variableReference'
	classVariableNames: 'FastDNUClass'
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!VariableReferenceProxy class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 09:58'!
fastDNUClass

	"recompute each time in case smth changed"

	FastDNUClass := Behavior new.
	FastDNUClass setFormat: self format.
	FastDNUClass methodDict: methodDict. "since this is not a deep copy the two classes are in sync ?"
	FastDNUClass superclass: nil.
	^ FastDNUClass.! !

!VariableReferenceProxy class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 09:58'!
new
	
	| newInstance |
	
	newInstance := self basicNew initialize.
	self fastDNUClass adoptInstance: newInstance.
	^ newInstance! !

!VariableReferenceProxy methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:01'!
__disable

	VariableReference adoptInstance: self. "revert FastDNU"! !

!VariableReferenceProxy methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 09:59'!
__instrumentedObject
	^ instrumentedObject! !

!VariableReferenceProxy methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 09:59'!
__instrumentedObject: anObject
	instrumentedObject := anObject! !

!VariableReferenceProxy methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:02'!
__isAVariableReferenceProxy

	^ true! !

!VariableReferenceProxy methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:00'!
__variableReference
	^ variableReference! !

!VariableReferenceProxy methodsFor: 'accessing' stamp: 'NickPapoulias 9/10/2015 10:00'!
__variableReference: anObject
	variableReference := anObject! !

!VariableReferenceProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/10/2015 10:49'!
doesNotUnderstand: aMessage
			
	^ variableReference execute: aMessage selector withArgs: aMessage arguments forOwner: instrumentedObject from: self.! !

DummyClass initialize!
